#!/usr/local/bin/perl
# ----------------------------------------------------------------------*
# 									*
#   COPYRIGHT(C)1998-2000 IIZUKA,Shinji. All Right reserved.		*
# 									*
#   pwbpop.cgi - WEB based POP3 client(Perl version)			*
# 									*
#   author : IIZUKA,Shinji(siizuka@nurs.or.jp)				*
# 									*
# ----------------------------------------------------------------------*
# 									*
#   parmeters(all parameters are retrieved by POST method)		*
# 									*
#      S : pop3 server name						*
#      u : user name							*
#      p : password of user						*
#      m : method							*
#      a : use apop when TRUE(1)					*
#      t : port no(110 when blank)					*
#      c : command of method						*
#         m = 0/none  initial panel					*
#         m = 1       console mode view					*
#         m = 2       retrieve subject ( c = no of msg: all when zero )	*
#         m = 3       retrieve message ( c = no of msg: all when zero )	*
#         m = 4       delete   subject ( c = no of msg: all when zero )	*
# 									*
# ----------------------------------------------------------------------*
#  history:								*
# 	1997.08.01	v1	created					*
# 	1997.10.02	v2	add MIME decode process			*
# 	1997.03.21	v3	Integrate wbmail.cgi			*
# 	1998.03.23	v3.1	Change "new-line" to server		*
# 	1998.03.25	v3.2	Decode user name and password		*
# 	1998.04.20	v4	Update method to retrieve/delete mail	*
# 	          		Add dump mode(contents of mailbox only)	*
# 	1998.05.27	v4.1	Add "-DLINUX" option for linux		*
# ----------------------------------------------------------------------
$version   = "Version p4.6(2000.03.16)";
$copyright = "Copyright(C)1999-2000 IIZUKA,Shinji(<A HREF=\"mailto:siizuka\@nurs.or.jp\">siizuka\@nurs.or.jp</A>).All right reserved.";
$ident = "@(#)pwbpop.cgi 2000.03.16 vp4.6";

use Socket;
require	"jcode.pl";
require	"md5.pl";

# ------------------------------------ *
#  	Logical type
# ------------------------------------ *

# ----------------------------------------------------------------------*
# 									*
# 	Global variables						*
# 									*
# ----------------------------------------------------------------------
$is_dump_mode = 0;	# Use dump mode if TRUE		

#  MIME B encoding table. i.e:  t64['A'] == 1	
@t64 = (
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# 0 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# 1 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,62,-1,-1,-1,63,	# 2 
	  52,53,54,55,56,57,58,59,60,61,-1,-1,-1, 0,-1,-1,	# 3 
	  -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,	# 4 
	  15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,	# 5 
	  -1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,	# 6 
	  41,42,43,44,45,46,47,48,49,50,51,-1,-1,-1,-1,-1,	# 7 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# 8 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# 9 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# A 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# B 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# C 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# D 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,	# E 
	  -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1);	# F 
	# 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F

$QE_HEAD = '=?ISO-2022-JP?Q?';	# Header of MIME Q encode
$BE_HEAD = '=?ISO-2022-JP?B?';	# Header of MIME E encode

$F_METHOD	= "m";
$F_HOST		= "s";
$F_USER		= "u";
$F_PASSWD	= "p";
$F_APOP		= "a";
$F_PORTNO	= "t";

$FM_CONSOLE	= '1';
$FM_HEAD	= '2';
$FM_PROPER	= '3';
$FM_DUMP	= '5';

$TRUE           = 1;
$FALSE          = 0;

$default_port   = 110;

# ***********************************************************************
# 	base libraries							*
# **********************************************************************

# ----------------------------------------------------------------------*
# 									*
# 	dbg_print() print into DBG					*
# 									*
# ----------------------------------------------------------------------
sub	dbg_print {
# 	print STDERR $_[0];
1;
}
# open( STDERR, ">pwbpop.log" );
# $oldfh = select(STDERR); $| = 1; select($oldfh); 

# ----------------------------------------------------------------------*
# 
# 	main control
# 
# ----------------------------------------------------------------------*

# Initial Process
$pgmname = $0;
$cgi_name = &basename($0);

# STDERR->autoflush(1);

#select(DBG); $| = 1; select(STDOUT);

# Get CGI Parameters
if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
} else {
	$buffer = $ENV{"QUERY_STRING" };
}

@pairs = split(/&/,$buffer);

foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}

# set dump_mode_flag
&dbg_print ( "method = $FORM{$F_METHOD}\n" );
do { &display_initial_panel;exit(0) } unless ( $FORM{$F_METHOD} =~ /^[12345]$/ );

$is_dump_mode = ($FORM{$F_METHOD} eq $FM_DUMP );

# print out header information
if ( $is_dump_mode ) {
	print "Content-type: text/plain\n\n";
} else {
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Web Based POP3 Service - Execution view\n";
	print "</TITLE></HEAD><BODY BGCOLOR=#ffffff><CENTER><FONT SIZE=+2>\n";
	print "Web Based POP3 Service - result</FONT></CENTER>\n";
	&display_copyright( "RIGHT" );
	print "<p><FONT COLOR=green>------ execution log -------</FONT></p>\n";
}

# Connet to remote host
if ( !( $FORM{$F_PORTNO} =~ /^[0-9]+$/ ) ) {
	$FORM{$F_PORTNO} = 110;
} else {
	$FORM{$F_PORTNO} = $FORM{$F_PORTNO} - 0;
}

&connect_to_remote_host( $FORM{$F_HOST},$FORM{$F_PORTNO} ) || do {
	print  "<FONT COLOR=RED>Process terminated.</FONT><BR>\n" if !($is_dump_mode);
	exit( 0 );
};

# login to mail server
&dbg_print ("now connected,starting to login...\n");
&login_to_mail_server;

#  Retrieve number of mail
&retr_mail_list;

#  Get mails
if ( $FORM{$F_METHOD} eq $FM_CONSOLE || $FORM{$F_METHOD} eq $FM_DUMP ) {
	print " <FORM NAME=f METHOD=POST ACTION=\"$cgi_name\">" unless ( $is_dump_mode );
	&retrieve_mail( 0, $mail_cnt );
	do {
		&display_input_area( 0 ) ;
		print "</FORM>";
	} unless $is_dump_mode;
}
if ( $FORM{$F_METHOD} eq $FM_HEAD ) {
	&dbg_print ( "now doing retrieve_head...\n");
	&retrieve_head( 0, $mail_cnt );
}
if ( $FORM{$F_METHOD} eq $FM_PROPER ) {
	print " <FORM NAME=f METHOD=POST ACTION=\"$cgi_name\">";
	for ( $ix = 1; $ix <= $mail_cnt; $ix++ ) {
		do {
			&retrieve_mail( $ix, $mail_cnt );
		} if ( "on" eq $FORM{"R$ix"} );
	}
	for ( $ix = 1; $ix <= $mail_cnt; $ix++ ) {
		&input_cmd ( "DELE $ix\r\n") if ( "on" eq $FORM{"D$ix"} );
	}
	do {
		&display_input_area( 0 ) ;
		print "</FORM>\n";
	} unless $is_dump_mode;
}

#  QUIT 
&input_cmd ("QUIT\r\n" );
close ( S );

# close (STDOUT); open ( STDOUT, ">&SAVEOUT");open(RES,"<..\\doc\\pwbpop.htm"); $moji = <RES>; print $moji;close(RES);
exit( 0 );

# ----------------------------------------------------------------------*
#
#	basename - as the same name of unix command
#
# ----------------------------------------------------------------------

sub	basename {
	@path_ary = split ( /[\\\/]/, $_[0] );
	return ( $path_ary[$#path_ary] );
}

# ----------------------------------------------------------------------*
# 									*
# 	is_mime_B/is_mime_Q - test whether string includes MIME sequence*
# 									*
# ----------------------------------------------------------------------
sub is_mime_B {
	return ( $_[0] =~ /\=\?ISO\-2022\-JP\?B\?[\+\/0-9\=A-Za-z]+\?\=/);
}
sub is_mime_Q {
	return ( $_[0] =~ /\=\?ISO\-2022\-JP\?Q\?[\+\/0-9\=A-Za-z]+\?\=/);
}

# ----------------------------------------------------------------------
#
#	connect_to_remote_host ( ) - create connecton
#
# ----------------------------------------------------------------------
sub	connect_to_remote_host {
	local($them)     = $_[0];
	local($port)     = $_[1] - 0;
	local($sockaddr) = 'S n a4 x8';
#	$hostname = "localhost";
#	chop($hostname = `hostname`);

	print "<FONT COLOR=green>resolving $them. please wait...<BR></FONT>\n"
		unless $is_dump_mode;

#	($name, $aliases, $proto) = getprotobyname('tcp');
#	($name, $aliases, $port)  = getservbyname($port, 'tcp') unless $port =~ /^\d+$/;
#	($name, $aliases, $type, $len, $thisaddr) = gethostbyname($hostname);
	($name, $aliases, $type, $len, $thataddr) = gethostbyname($them);

#	$this = pack($sockaddr, &AF_INET, 0, $thisaddr);
	$that = pack($sockaddr, &AF_INET, $port, $thataddr);

	socket(S, &PF_INET, &SOCK_STREAM, $proto) || do {
		print "<FONT COLOR=red>fatal: failed to call socket() ($!)</FONT><BR>\n" unless $is_dump_mode;
		return ( 0 );
	};
	&dbg_print ("successed to socket()\n");

#	bind(S, $this) || do {
#		print "<FONT COLOR=red>fatal: failed to call bind() ($!)</FONT><BR>\n" unless !($is_dump_mode);
#		return ( 0 );
#	};
#	&dbg_print ("successed to bind()\n");

	print "<FONT COLOR=green>connecting $them using $port ...<BR></FONT>\n"
		unless !($is_dump_mode);

	connect(S, $that) || do {
		if ( !($is_dump_mode) ) {
			print "<FONT COLOR=red>failed to call connect() ($!)</FONT><BR>\n";
			print "<FONT COLOR=red>It may be due to too many connections ";
			print "or server down.</FONT><BR>\n";
		}
# 		shutdown( s, 2 );
		close ( S );
		return ( 0 );
	};
	&dbg_print ("successed to connect()\n");
	select(S); $| = 1; select(stdout);
	return ( 1 );
}


# ----------------------------------------------------------------------
#
#	login_to_mail_server - as the name of the function
#
# ----------------------------------------------------------------------
sub login_to_mail_server {
	$apop_str = "";
	$r_line = <S>;
	print "$r_line<BR>" unless $is_dump_mode;
	&dbg_print ("$r_line\n");

	if ( $FORM{$F_APOP} =~ /^[Oo][Nn]$/ ) {
		$apop_str = &get_apop_hex_digest( $r_line, $FORM{$F_PASSWD} );
		if ( $apop_str ne "" ) {
			&input_cmd( "APOP $FORM{$F_USER} $apop_str\r\n" ) || do { close(S); exit(0)};
		}
	}
	if ( $apop_str eq "" ) {
		&input_cmd       ( "USER $FORM{$F_USER}\r\n" )   || do { close(S);exit (0) };
		&input_cmd_crypt ( "PASS $FORM{$F_PASSWD}\r\n" ) || do { close(S);exit (0) };
	}
}

# ***********************************************************************
# 	functions							*
# *********************************************************************
# ----------------------------------------------------------------------*
# 									*
# 	input_cmd() - send cmd to POP server until max retry(2)		*
# 		reached or execution of command successed		*
# 									*
# ----------------------------------------------------------------------
sub	input_cmd {
	if ( $_[1] ne 'silent' && $_[1] ne 'stealth' ) {
		print "<FONT COLOR=blue>$_[0]<BR></FONT>" unless $is_dump_mode;
	}
	&dbg_print ("$_[0]");
	print S $_[0] || return( 0 );
	&dbg_print ("now entered $_[0]" );

	if ( $_[1] ne 'silent' && $_[1] ne 'nowait' ) {
		&dbg_print ( "now waiting for response...\n");
		$r_line = <S>;
		&dbg_print( "[RES]$r_line" );
	}
	if ( $_[1] ne 'silent' && $_[1] ne 'nowait' && $_[1] ne 'stealth' ) {
		print "$r_line<BR>" unless $is_dump_mode;
	}
	return ( $r_line =~ /^\+/ );
}

# ----------------------------------------------------------------------*
# 									*
# 	input_cmd_crypt() - send cmd to POP server until max retry(2)	*
# 		reached or execution of command successed		*
#i 									*
# ----------------------------------------------------------------------
sub	input_cmd_crypt {
	local($c_moji) = $_[0];
	$c_moji =~ s/^PASS //; $c_moji =~ s/./\*/g;
	$c_moji = "PASS $c_moji";
	
	if ( $_[1] ne 'silent' && $_[1] ne 'stealth' ) {
		print "<FONT COLOR=blue>$c_moji<BR></FONT>" unless $is_dump_mode;
	}
	&dbg_print ("$c_moji");
	print S $_[0] || return( 0 );

	&dbg_print ("now entered $c_moji, waiting for response\n");
	if ( $_[1] ne 'silent' && $_[1] ne 'nowait' ) {
		$r_line = <S>;
	}
	if ( $_[1] ne 'silent' && $_[1] ne 'nowait' && $_[1] ne 'stealth' ) {
		print "$r_line<BR>" unless $is_dump_mode;
	}
	return ( $r_line =~ /^\+/ );
}

# ----------------------------------------------------------------------*
# 									*
# 	retr_mail_list() - retrieve number of mail(s)			*
# 									*
# ----------------------------------------------------------------------
sub	retr_mail_list {

	&input_cmd ( "LIST\r\n",'nowait' ) || exit( 0 );
	@ary_line = ();	# Null
	@ary_size = (); # Null

	$mail_cnt = 0;
	while ( <S> ) {
		$r_line = $_;
		print "$r_line<BR>" unless $is_dump_mode;
		&dbg_print ($r_line);
		local($r_cmd) = $r_line;
		$r_cmd =~ s/\n//g;
		$r_cmd =~ s/\r//g;
		last if ( $r_cmd =~ /^\.$/ );
		@ary_line = split ( /[ \t\n]+/, $r_line, 2 );
		$mail_cnt = $ary_line[0] + 0;
		push ( @ary_size, $ary_line[1] + 0 );
	}
	&dbg_print ( "number of mail is $mail_cnt\n");
}

# ----------------------------------------------------------------------*
# 									*
# 	display_input_area - as the name of subroutine			*
# 									*
# ----------------------------------------------------------------------

sub	display_input_area {
	print( "<TABLE BORDER=1>\n" );

	print "<TR>\n";
	print "<TD>DNS name of your POP3 server</TD>\n";
	printf(  "<TD><INPUT TYPE=text NAME=%s SIZE=60 value=%s></TD>\n", $F_HOST, $FORM{$F_HOST} );
	print "</TR>\n";

	print "<TR>\n";
	print "<TD>Port number of your POP3 server<BR>(110 when blank)</TD>\n";
	printf(  "<TD><INPUT TYPE=text NAME=%s SIZE=10 VALUE=%s></TD>\n", $F_PORTNO, ($FORM{$F_PORTNO} ne "" ? $FORM{$F_PORTNO} : "110" ) );
	print "</TR>\n";

	print "<TR>\n";
	print "<TD>Your account</TD>\n";
	printf(  "<TD><INPUT TYPE=text NAME=%s SIZE=60 value=%s></TD>\n", $F_USER, $FORM{$F_USER} );
	print "</TR>\n";

	print "<TR>\n";
	print "<TD>Password for your account</TD>\n";
	printf(  "<TD><INPUT TYPE=password NAME=%s SIZE=60></TD>\n", $F_PASSWD );
	print "</TR>\n";

	printf(  "</TABLE>\n" );

	printf(  "<P><INPUT TYPE=radio NAME=%s VALUE=%s>Console mode\n", $F_METHOD, $FM_CONSOLE );

	printf(  "<INPUT TYPE=radio NAME=%s VALUE=%s %s>Header only\n",$F_METHOD, $FM_HEAD, ($FORM{$F_METHOD} != $FM_HEAD ? "CHECKED" : "" ) );
	printf(  "<INPUT TYPE=radio NAME=%s VALUE=%s %s>Retrieve/Delete Seleced Mail\n", $F_METHOD, $FM_PROPER, ($FORM{$F_METHOD} == $FM_HEAD ? "CHECKED" : "") );
	printf(  "<INPUT TYPE=radio NAME=%s VALUE=%s>Dump Mode\n", $F_METHOD, $FM_DUMP );
	printf(  "<BR><INPUT TYPE=checkbox NAME=%s>Use APOP authorization<BR>\n", $F_APOP );

	print << "EOF"
<SCRIPT LANGUAGE="JavaScript">
<!--//
document.write ( '<INPUT TYPE=button value="Execute" onClick="execute_it();return(0);">' );
//-->
</SCRIPT>
<NOSCRIPT>
<INPUT TYPE=submit value="Execute">
</NOSCRIPT>
<INPUT TYPE=reset value="Reset">
</P>
EOF
;
}

# ----------------------------------------------------------------------*
# 									*
# 	print_js_head() - print header line of javascript		*
# 									*
# ----------------------------------------------------------------------*
sub	print_js_head {
	print << "EOF"
<SCRIPT LANGUAGE="JavaScript">

<!--//
read_key = "R"; delete_key = "D";
function execute_it( ) {
  for ( ix = 0; ix < document.f.m.length && document.f.m[ix].value != 3; ix++ ) ;
  if ( document.f.m[ix].value == 3 ) {
    if ( document.f.m[ix].checked ) {
      check_cnt = 0
      for ( ix = 0; ix < document.f.elements.length; ix++ ) {
        if ( document.f.elements[ix].type == "checkbox" ) {
          ident = document.f.elements[ix].name.substring(0,1);
          if ( ident == read_key || ident == delete_key ) {
            if ( document.f.elements[ix].checked == true ) {
              check_cnt++;
            }
          }
        }
      }
      if ( check_cnt < 1 ) {
        alert( "Check \\\"Read\\\" checkbox or \\\"Delete\\\" checkbox." );
        return(0);
      }
    }
  }
  if ( document.f.s.value == "" ) {
    alert( "Input the name of your POP3 Server." );
    document.f.s.focus();
    return(0);
  }
  if ( document.f.u.value == "" ) {
    alert( "Input your account." );
    document.f.u.focus();
    return(0);
  }
  if ( document.f.p.value == "" ) {
    alert( "Input the password of your account." );
    document.f.p.focus();
    return(0);
  }
  document.f.submit();
}
//-->

</SCRIPT>
<BR>
EOF
;
}


# ----------------------------------------------------------------------*
# 									*
# 	print_js_select_all_mail() - as the name of function		*
# 									*
# ----------------------------------------------------------------------*
sub print_js_select_all_mail {
print << "EOF"
<SCRIPT LANGUAGE="JavaScript">

<!--//
function check_all( k,b ) {
  for ( ix = 0; ix < document.f.elements.length; ix++ ) {
    if ( document.f.elements[ix].type == "checkbox" ) {
      if ( document.f.elements[ix].name.substring(0,1) == k ) { 
        if ( document.f.elements[ix].checked != b ) { 
          document.f.elements[ix].click();
        }
      }
    }
  }
}
//-->

</SCRIPT>
EOF
;
}

# ----------------------------------------------------------------------*
# 									*
# 	print_javascript_indicate() - as the name of function		*
# 									*
# ----------------------------------------------------------------------*
sub	print_javascript_indicate {
print << "EOF"
<SCRIPT LANGUAGE="JavaScript">
<!--//

document.write ( '<INPUT TYPE=BUTTON VALUE="ON all(read)" onClick="check_all(read_key,true);return(0)">');
document.write ( '<INPUT TYPE=BUTTON VALUE="OFF all(read)" onClick="check_all(read_key,false);return(0)"> ');
document.write ( '<INPUT TYPE=BUTTON VALUE="ON all(del)" onClick="check_all(delete_key,true);return(0)">');
document.write ( '<INPUT TYPE=BUTTON VALUE="OFF all(del)" onClick="check_all(delete_key,false);return(0)">');
//-->
</SCRIPT><BR>
EOF
;
}

# ----------------------------------------------------------------------*
# 									*
# 	display_initial_panel()	- just as name of function		*
# 									*
# ----------------------------------------------------------------------
sub	display_initial_panel {
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Web Based POP3 Service\n";
	print "</TITLE></HEAD><BODY BGCOLOR=white><CENTER>\n";
	print "<FONT SIZE=+2>Web Based POP3 Service</FONT>\n";
	print "</CENTER><P>\n";
	&display_copyright( "RIGHT" );
	print " <FORM NAME=f METHOD=POST ACTION=\"$cgi_name\"></P>";
	&display_input_area ;
	print "</FORM>";
}

# ----------------------------------------------------------------------*
# 									*
# 	display_copyright()	- just as name of function		*
# 									*
# ----------------------------------------------------------------------
sub	display_copyright {
	print "<P ALIGIN=RIGHT>$version.<BR>$copyright<BR>";
	print  " This page is served &quot;AS IS&quot;.";
	print  "Use this service at your own risk</P>";
	&print_js_head;
}

# ----------------------------------------------------------------------*
# 									*
# 	decode_mime_B ( ) - convert MIME B encodeed data		*
# 									*
# ----------------------------------------------------------------------

sub	decode_mime_B {
	$moji = $_[0];
	$moji =~ s/\?\=$//;
	$moji =~ s/^\=\?[Ii][Ss][Oo]\-2022\-[Jj][Pp]\?[Bb]\?//;

	# determin start pointer of data area 
	local($ix) = 0; $after = '';

	while ( $ix < length ($moji) ) {
		# decode first character
		$before = ();
		$c[0] = substr($moji,$ix++,1); $before[0] = $t64[ord($c[0])];
		$c[1] = substr($moji,$ix++,1); $before[1] = $t64[ord($c[1])];
		$c[2] = substr($moji,$ix++,1); $before[2] = $t64[ord($c[2])];
		$c[3] = substr($moji,$ix++,1); $before[3] = $t64[ord($c[3])];
		$after .= pack("c",(($before[0]<<2) & 0xfc) + (($before[1]>>4) & 0x03));
		$after .= pack("c",(($before[1]<<4) & 0xf0) + (($before[2]>>2) & 0x0f)) if ( $c[2] ne '=' );
		$after .= pack("c",(($before[2]<<6) & 0xc0) + (($before[3]   ) & 0x3f)) if ( $c[3] ne '=' );
	}
	return ( $after );
}

# ----------------------------------------------------------------------*
# 									*
# 	decode_mime_Q ( ) - convert MIME Q encodeed data		*
# 									*
# ----------------------------------------------------------------------
sub	decode_mime_Q {
	$after = $_[0];
	$after =~ s/\?\=$//;
	$after =~ s/^\=\?[Ii][Ss][Oo]\-2022\-[Jj][Pp]\?[Qq]\?//;
	$after =~ s/=([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$after =~ s/_/ /;
	return ($after);
}

# ----------------------------------------------------------------------*
# 									*
# 	fmt_into_txt() -	format input line into text		*
# 									*
# ----------------------------------------------------------------------
sub	fmt_into_txt {
	$after = $_[0];
	jcode'convert( *after, 'euc');
	$after =~ s/\</\&lt\;/g;
	$after =~ s/\>/\&gt\;/g;
	$after =~ s/\"/\&quot\;/g;
	$after =~ s/(http:\/\/[0-9a-zA-Z\~\%\_\-\#\=\/\@\.]+?)([^0-9a-zA-Z\~\%\_\-\#\=\/\@\.])/\<A HREF=\"$1\"\>$1\<\/A\>$2/g;
	$after =~ s/(http:\/\/[0-9a-zA-Z\~\%\_\-\#\=\/\@\.]+?)$/\<A HREF=\"$1\"\>$1\<\/A\>/g;
	jcode'convert( *after, 'jis');
	return ($after);
}


# ----------------------------------------------------------------------*
# 									*
# 	get_apop_hex_didgest() - get hex expression of MD5 digest	*
# 				 for APOP authorization			*
# 									*
# ----------------------------------------------------------------------*
sub	get_apop_hex_digest {	# line, password / returning apop_str
	# Find the start of timestamp
	$_[0] =~ /(\<..*\>)/; $apop_salt = $1;
	return( "" ) if ( $apop_salt eq "" );

	$apop_salt .= $_[1];
	$digest = &md5'convert( $apop_salt );
	return( sprintf("%08x%08x%08x%08x\n", unpack('NNNN', $digest)) );
}

# ----------------------------------------------------------------------*
# 									*
# 	get_mail_date() - get date of mail				*
# 									*
# ----------------------------------------------------------------------
sub	get_mail_date {
	local($the_date) = $_[0];
	$the_date =~ /(.*) [\+\-]?[0-9]+[ \t]*$/;
	if ( $1 eq "" ) {
		return( $the_date );
	} else {
		return( $1 );
	}
}

# ----------------------------------------------------------------------*
# 									*
# 	decode_str_of_mime () - convert mail into adequate format	*
# 									*
# ----------------------------------------------------------------------*
sub	decode_str_of_mime {
	local($rtn_str)     = "";
	local($not_encoded) = $_[0];
	local($encoded)     = "";
	local($encoding)    = "";

	while ( $not_encoded =~ /\=\?[iI][sS][oO]\-2022\-[jJ][pP]\?[bB]\?[\+\/0-9A-Za-z]+\=*\?\=/){
		$encoded = $`;$not_encoded = $';$encoding = $&;
		$rtn_str .= $encoded;
		$rtn_str .= &decode_mime_B($encoding);
	}
	$not_encoded = $buf2 . $not_encoded;

	while ( $not_encoded =~ /\=\?[iI][sS][oO]\-2022\-[jJ][pP]\?[qQ]\?[\+\/0-9A-Za-z]+\=*\?\=/){
		$encoded = $`;$not_encoded = $';$encoding = $&;
		$rtn_str .= $encoded;
		$rtn_str .= &decode_mime_Q($encoding);
	}
	return( $rtn_str . $not_encoded );
}

# ----------------------------------------------------------------------*
# 									*
# 	retrieve_header_line() - retrieve a line of header		*
# 									*
# ----------------------------------------------------------------------*
sub retrieve_header_line {
	local($is_first) = $_[1];
	#  set from previous buffer	
	if ( $is_first ) {	#  when no buffer 
		$is_first = $FALSE;
		$is_last  = $FALSE;
		$_[0] = <S>; $_[0] =~ s/\n//g; $_[0] =~ s/\r//g;
	} else {
		if ( $is_last == $TRUE ) {
			$is_last = $FALSE; $is_first = $TRUE;
			$prev_rec = "";
			$_[0] = "";
			return( 0 )
		} else {
			$_[0] = $prev_rec;
		}
	}

	#  read current record	
	while(<S>) {
		$r_line = $_; $r_line =~ s/\n//g; $r_line  =~ s/\r//g;
		if ( $r_line eq "" || $r_line =~ /^\.[^\.]*/ || !( $r_line =~ /^ / ) ) {
			#  set previous buffer 
			$prev_rec = $r_line;
			$is_last = $TRUE if ( $r_line =~ /^\.[^\.]*/  || $r_line eq "" );
			return( length( $_[0] ) );
		}
		$_[0] .= substr($r_line,1);
	}
}

# ----------------------------------------------------------------------*
# 									*
# 	retrieve_each_head() - retrieve header ( all when no. = 0 )	*
# 									*
# ----------------------------------------------------------------------
sub retrieve_each_head {
# gets    is_display
# returns subject,from,date,mime_type,boundary, filename
	local($boundary)  = "";
	local($mime_type) = "";
	local($filename)  = "";
	local($subject)   = "";
	local($from)      = "";
	local($date)      = "";

	#  Process reply 
	$nbyte = &retrieve_header_line( $buf, $TRUE );
	while( $nbyte > 0 ) {
		#  process $buffer
		if ( $boundary eq "" && $buf =~ /^Content-Type: / ) {
			$buf =~ /boundary\=\"(.+?)\"/; $boundary  = $1;
		}

		if ( $mime_type eq ""  && $buf =~ /^Content-Type: / ) {
			$buf =~ /Content-Type: ([^ \t\n][^ \t\n]*)/; $mime_type = $1;
		}

		if ( $filename eq "" && $buf =~ /^Content\-Disposition\: / ) {
			$buf =~ /name\=\"(.+?)\"/; $filename = $1;
			$filename = &decode_str_of_mime( $filename );
			$filename = &fmt_into_txt($filename);
		}

		$buf = &decode_str_of_mime( $buf );
		$buf = &fmt_into_txt ( $buf );
		print  "$buf\n" if ( $_[0] == $TRUE );

		if ( $subject eq "" && $buf =~ /^Subject\: / ) {
			$buf =~ /Subject: (.*)$/   ;
			$subject = $1;
			&dbg_print( "retrieve_each_head :4 enterd to test subject($buf) -> $1\n" );
		}
		if ( $from    eq "" && $buf =~ /^From\: /    ) { $buf =~ /From: (.*)$/ ; $from    = $1; }
		if ( $date    eq "" && $buf =~ /^Date\: /    ) { $buf =~ /Date: (.*)$/ ; $date = &get_mail_date( $1 ); }
		$nbyte = &retrieve_header_line( $buf, $FALSE );
		&dbg_print( "retrieve_each_head :3 buf = |$buf|, nbyte = $nbyte\n" );
	}

	return( ( $subject, $from, $date, $mime_type, $boundary, $filename) );
}

# --------------------------------------------------------------------------------------*
# 											*
# 	retrieve_related_message() - retrieve contents of alternative message		*
# 											*
# --------------------------------------------------------------------------------------*
sub retrieve_related_message {
	#  Main Header 
	local($boundary)  = $_[0];
	local($filname)   = "";
	local($mime_type) = "";

	for(;;) {
		if ( $r_line =~ /^\-\-$boundary$/ ) { 
			( $dmy1, $dmy2, $dmy3, $mime_type, $dmy4, $filename ) = &retrieve_each_head( $FALSE );

#			if ( $mime_type =~ /text\/html/ ) { # no statement
#			} else {  			# no statement
#			}

		} elsif ( $r_line =~ /^\-\-$boundary\-\-$/ ) { 
			return( 0 );
		}
		do { return( 0 ); } if ( $r_line =~ /^\.[^\.]*/ ) ;
		$r_line = <S>;
		$r_line  =~ s/\r//g;
	}
}

# ----------------------------------------------------------------------*
# 									*
# 	retrieve_proper_mail() - retrieve mail 				*
# 									*
# ----------------------------------------------------------------------
sub retrieve_proper_mail {
	#  Main Header 
	$boundary = "";
	( $dmy1, $dmy2, $dmy3, $mime_type, $boundary, $dmy4 ) = &retrieve_each_head( $TRUE );

	$boundary2 = "";

	return( 0 ) if ( $r_line =~ /^\.[^\.]*/ );
	$r_line .= "\n";

	$in_attach = $FALSE;
	for(;;) {
		if ( $r_line =~ /^\-\-$boundary$/ ) { 
			( $dmy1, $dmy2, $dmy3, $mime_type, $boundary2, $filename ) = &retrieve_each_head( $FALSE );
			SWITCH: { 
			    if ( $mime_type =~ /^text\/plain/ ) {
				$in_attach = $FALSE;
				last SWITCH;
			    }
			    if ( $mime_type =~ /^multipart\/related/ ) {
				print "<B>This mail contains alternative(s)(perhaps HTML)</B>\n";
				&retrieve_related_message( $boundary2 );
				$r_line = <S>;
				$r_line  =~ s/\r//g;
				$in_attach = $FALSE;
				last SWITCH;
			    }
			    do { #default
				print "<B>Attached File: $filename</B>\n";
				$in_attach = $TRUE;
				last SWITCH;
			    }
			}
		}

		if ( $r_line =~ /^\-\-$boundary\-\-$/ ) {
			#  ignore this line 
		} else {
			do { $r_line =~ s/^\.\./\./; print &fmt_into_txt( $r_line ) ; } if ( !( $in_attach ) );
		}
		do { return( 0 ); } if ( $r_line =~ /^\.[^\.]*/ ) ;

		$r_line = <S>;
#		$r_line =~ s/\n//g;
		$r_line  =~ s/\r//g;
#		chomp($r_line);
#		return( 0 ) if ( $r_line eq "" );
	}
}

# ----------------------------------------------------------------------*
# 									*
# 	retrieve_mail() - retrieve prefer mail ( all when no. = 0 )	*
# 									*
# ----------------------------------------------------------------------
sub retrieve_mail {
	local($is_ok) = $FALSE;

	local($ix) = 0;
	local($min_ix) = ( $_[0] == 0 ? 1     : $_[0] );
	local($max_ix) = ( $_[0] == 0 ? $_[1] : $_[0] );

	for ( $ix = $min_ix; $ix <= $max_ix; $ix++) {
		print "<HR>\n";
		&input_cmd ( "RETR $ix\r\n", 'nowait' );
		if ( $is_dump_mode == $TRUE ) {
			&dump_proper_mail;
		} else {
			print "<P><PRE>";
			&retrieve_proper_mail;
			print "</PRE>";
			print "<INPUT TYPE=checkbox NAME=R$ix>Re-retrieve this mail ";
			print "<INPUT TYPE=checkbox NAME=D$ix>Delete this mail</P>\n";
		}
	}
}

# ----------------------------------------------------------------------*
# 									*
# 	retrieve_head() - retrieve prefer header ( all when no. = 0 )	*
# 									*
# ----------------------------------------------------------------------
sub retrieve_head  {
# int no, int mail_cnt
	printf( " <FORM NAME=f METHOD=POST ACTION=\"%s\">", $cgi_name );
	printf( "<TABLE BORDER=1 WIDTH=\"100%%\"><TR>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>Read</FONT></B></CENTER></TD>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>Delete</FONT></B></CENTER></TD>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>Date</FONT></B></CENTER></TD>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>Subject</FONT></B></CENTER></TD>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>From</FONT></B></CENTER></TD>\n" );
	printf( "<TD><FONT COLOR=GREEN><B><CENTER>Size</FONT></B></CENTER></TD></TR>\n" );

	local($ix) = 0;
	local($min_ix) = ( $_[0] == 0 ? 1     : $_[0] );
	local($max_ix) = ( $_[0] == 0 ? $_[1] : $_[0] );

	&dbg_print( "retrieve_head: 1 min = $min_ix, max = $max_ix\n" );
	for ( $ix = $min_ix; $ix <= $max_ix; $ix++) {
		&input_cmd("TOP $ix 1\r\n", 'stealth' );	#  Send command 
		$r_line =~ s/[\r\n]//g;
		$buf1 = $r_line;

		#  get replay 
		( $subject, $from, $date, $mime_type, $dmy1, $dmy2 ) = &retrieve_each_head( $FALSE );
		while( !($r_line =~ /^\.[^\/]*/) ) { $r_line = <S> };

		printf( "<TR><TD><INPUT TYPE=checkbox NAME=R%d></TD>\n", $ix );
		printf( "<TD><INPUT TYPE=checkbox NAME=D%d></TD>\n", $ix );
		printf( "<TD>%s</TD><TD>%s</TD><TD>%s</TD>", $date, $subject, $from );
		printf( "<TD>%d</TD></TR>\n", $ary_size[$ix] );
		printf( "</TR>\n" );
	}

	printf( "</TABLE><BR>\n" );
	&print_javascript_indicate;
	&display_input_area;
	printf( "</FORM>\n" );
}

